#ifdef _OPENMP
#include <omp.h>
#endif
#include <stdio.h>
#include <stdlib.h>

main (int argc, char *argv[]) 
{
   int id=0, nthreads=0;   

#pragma omp parallel private(id,nthreads)
{
	#pragma omp master
	{
		fprintf(stdout," Hello world from:\n");
	}
	
	#ifdef _OPENMP
		id=omp_get_thread_num();
		nthreads=omp_get_num_threads();
	#endif
	#pragma omp critical
	{
		fprintf(stdout," Thread id: %d; total number: %d\n",id, nthreads);
	}
}
   return(0);
}
